// A Bison parser, made by GNU Bison 3.7.6.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 14 "C:\\Users\\Vince\\Projects\\Enventive\\ensrc\\EnAp\\ApReadBinary.ypp"



#line 45 "C:\\Users\\Vince\\Projects\\Enventive\\ensrc\\EnAp\\ApReadBinary.tab.cpp"


#include "ApReadBinary.tab.hpp"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

namespace yy {
#line 142 "C:\\Users\\Vince\\Projects\\Enventive\\ensrc\\EnAp\\ApReadBinary.tab.cpp"

  /// Build a parser object.
  parser::parser ()
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr)
#else

#endif
  {}

  parser::~parser ()
  {}

  parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/



  // by_state.
  parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  parser::symbol_kind_type
  parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  parser::stack_symbol_type::stack_symbol_type ()
  {}

  parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_DVALVEC: // DVALVEC
        value.YY_MOVE_OR_COPY< EnDoubleVectorType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FVALVEC: // FVALVEC
        value.YY_MOVE_OR_COPY< EnFloatVectorType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_RAWBINVAL: // RAWBINVAL
        value.YY_MOVE_OR_COPY< EnRawBinaryDataType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_UVVAL: // UVVAL
        value.YY_MOVE_OR_COPY< EnUnsignedIntVectorType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IVVAL: // IVVAL
        value.YY_MOVE_OR_COPY< IntVector > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BVAL: // BVAL
        value.YY_MOVE_OR_COPY< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_DVAL: // DVAL
        value.YY_MOVE_OR_COPY< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FVAL: // FVAL
        value.YY_MOVE_OR_COPY< float > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IVAL: // IVAL
        value.YY_MOVE_OR_COPY< int > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_LVAL: // LVAL
        value.YY_MOVE_OR_COPY< long > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SVAL: // SVAL
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ULVVAL: // ULVVAL
        value.YY_MOVE_OR_COPY< std::vector<unsigned long> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_UVAL: // UVAL
        value.YY_MOVE_OR_COPY< unsigned int > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_DVALVEC: // DVALVEC
        value.move< EnDoubleVectorType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FVALVEC: // FVALVEC
        value.move< EnFloatVectorType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_RAWBINVAL: // RAWBINVAL
        value.move< EnRawBinaryDataType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_UVVAL: // UVVAL
        value.move< EnUnsignedIntVectorType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IVVAL: // IVVAL
        value.move< IntVector > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BVAL: // BVAL
        value.move< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_DVAL: // DVAL
        value.move< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FVAL: // FVAL
        value.move< float > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IVAL: // IVAL
        value.move< int > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_LVAL: // LVAL
        value.move< long > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SVAL: // SVAL
        value.move< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ULVVAL: // ULVVAL
        value.move< std::vector<unsigned long> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_UVAL: // UVAL
        value.move< unsigned int > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_DVALVEC: // DVALVEC
        value.copy< EnDoubleVectorType > (that.value);
        break;

      case symbol_kind::S_FVALVEC: // FVALVEC
        value.copy< EnFloatVectorType > (that.value);
        break;

      case symbol_kind::S_RAWBINVAL: // RAWBINVAL
        value.copy< EnRawBinaryDataType > (that.value);
        break;

      case symbol_kind::S_UVVAL: // UVVAL
        value.copy< EnUnsignedIntVectorType > (that.value);
        break;

      case symbol_kind::S_IVVAL: // IVVAL
        value.copy< IntVector > (that.value);
        break;

      case symbol_kind::S_BVAL: // BVAL
        value.copy< bool > (that.value);
        break;

      case symbol_kind::S_DVAL: // DVAL
        value.copy< double > (that.value);
        break;

      case symbol_kind::S_FVAL: // FVAL
        value.copy< float > (that.value);
        break;

      case symbol_kind::S_IVAL: // IVAL
        value.copy< int > (that.value);
        break;

      case symbol_kind::S_LVAL: // LVAL
        value.copy< long > (that.value);
        break;

      case symbol_kind::S_SVAL: // SVAL
        value.copy< std::string > (that.value);
        break;

      case symbol_kind::S_ULVVAL: // ULVVAL
        value.copy< std::vector<unsigned long> > (that.value);
        break;

      case symbol_kind::S_UVAL: // UVAL
        value.copy< unsigned int > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_DVALVEC: // DVALVEC
        value.move< EnDoubleVectorType > (that.value);
        break;

      case symbol_kind::S_FVALVEC: // FVALVEC
        value.move< EnFloatVectorType > (that.value);
        break;

      case symbol_kind::S_RAWBINVAL: // RAWBINVAL
        value.move< EnRawBinaryDataType > (that.value);
        break;

      case symbol_kind::S_UVVAL: // UVVAL
        value.move< EnUnsignedIntVectorType > (that.value);
        break;

      case symbol_kind::S_IVVAL: // IVVAL
        value.move< IntVector > (that.value);
        break;

      case symbol_kind::S_BVAL: // BVAL
        value.move< bool > (that.value);
        break;

      case symbol_kind::S_DVAL: // DVAL
        value.move< double > (that.value);
        break;

      case symbol_kind::S_FVAL: // FVAL
        value.move< float > (that.value);
        break;

      case symbol_kind::S_IVAL: // IVAL
        value.move< int > (that.value);
        break;

      case symbol_kind::S_LVAL: // LVAL
        value.move< long > (that.value);
        break;

      case symbol_kind::S_SVAL: // SVAL
        value.move< std::string > (that.value);
        break;

      case symbol_kind::S_ULVVAL: // ULVVAL
        value.move< std::vector<unsigned long> > (that.value);
        break;

      case symbol_kind::S_UVAL: // UVAL
        value.move< unsigned int > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  parser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::operator() ()
  {
    return parse ();
  }

  int
  parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex ());
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_DVALVEC: // DVALVEC
        yylhs.value.emplace< EnDoubleVectorType > ();
        break;

      case symbol_kind::S_FVALVEC: // FVALVEC
        yylhs.value.emplace< EnFloatVectorType > ();
        break;

      case symbol_kind::S_RAWBINVAL: // RAWBINVAL
        yylhs.value.emplace< EnRawBinaryDataType > ();
        break;

      case symbol_kind::S_UVVAL: // UVVAL
        yylhs.value.emplace< EnUnsignedIntVectorType > ();
        break;

      case symbol_kind::S_IVVAL: // IVVAL
        yylhs.value.emplace< IntVector > ();
        break;

      case symbol_kind::S_BVAL: // BVAL
        yylhs.value.emplace< bool > ();
        break;

      case symbol_kind::S_DVAL: // DVAL
        yylhs.value.emplace< double > ();
        break;

      case symbol_kind::S_FVAL: // FVAL
        yylhs.value.emplace< float > ();
        break;

      case symbol_kind::S_IVAL: // IVAL
        yylhs.value.emplace< int > ();
        break;

      case symbol_kind::S_LVAL: // LVAL
        yylhs.value.emplace< long > ();
        break;

      case symbol_kind::S_SVAL: // SVAL
        yylhs.value.emplace< std::string > ();
        break;

      case symbol_kind::S_ULVVAL: // ULVVAL
        yylhs.value.emplace< std::vector<unsigned long> > ();
        break;

      case symbol_kind::S_UVAL: // UVAL
        yylhs.value.emplace< unsigned int > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // input: %empty
#line 1873 "C:\\Users\\Vince\\Projects\\Enventive\\ensrc\\EnAp\\ApReadBinary.ypp"
        {
		YYACCEPT; 
	}
#line 797 "C:\\Users\\Vince\\Projects\\Enventive\\ensrc\\EnAp\\ApReadBinary.tab.cpp"
    break;


#line 801 "C:\\Users\\Vince\\Projects\\Enventive\\ensrc\\EnAp\\ApReadBinary.tab.cpp"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        std::string msg = YY_("syntax error");
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

#if YYDEBUG || 0
  const char *
  parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytname_[yysymbol];
  }
#endif // #if YYDEBUG || 0





  const signed char parser::yypact_ninf_ = -1;

  const signed char parser::yytable_ninf_ = -1;

  const signed char
  parser::yypact_[] =
  {
      -1,     0,    -1
  };

  const signed char
  parser::yydefact_[] =
  {
       2,     0,     1
  };

  const signed char
  parser::yypgoto_[] =
  {
      -1,    -1
  };

  const signed char
  parser::yydefgoto_[] =
  {
       0,     1
  };

  const signed char
  parser::yytable_[] =
  {
       2
  };

  const signed char
  parser::yycheck_[] =
  {
       0
  };

  const short
  parser::yystos_[] =
  {
       0,  1469,     0
  };

  const short
  parser::yyr1_[] =
  {
       0,  1468,  1469
  };

  const signed char
  parser::yyr2_[] =
  {
       0,     2,     0
  };


#if YYDEBUG
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "DVAL", "FVAL", "IVAL",
  "UVAL", "LVAL", "BVAL", "SVAL", "IVVAL", "UVVAL", "ULVVAL", "RAWBINVAL",
  "DVALVEC", "FVALVEC", "AF_SMART_POINTER_INT", "AF_SMART_POINTER_EXT",
  "AF_OBJECT_BODY", "AF_SMART_POINTER_LIST_BEGIN",
  "AF_SMART_POINTER_LIST_END", "AF_SMART_POINTER_EXT_PARENTS_MASTER",
  "AF_POINT4D_VECTOR_BEGIN", "AF_POINT4D_VECTOR_END",
  "AF_POINT4D_MULTI_ARRAY2D_BEGIN", "AF_POINT4D_MULTI_ARRAY2D_END",
  "AF_DOUBLE_VECTOR_BEGIN", "AF_DOUBLE_VECTOR_END",
  "AF_DOUBLE_MULTI_ARRAY2D_BEGIN", "AF_DOUBLE_MULTI_ARRAY2D_END",
  "AF_DYNAMIC_BITSET_BEGIN", "AF_DYNAMIC_BITSET_END",
  "AF_POINT3F_AUTO_VECTOR_BEGIN", "AF_POINT3F_AUTO_VECTOR_END",
  "AF_COLOR_AUTO_VECTOR_BEGIN", "AF_COLOR_AUTO_VECTOR_END",
  "AF_NORMAL3F_AUTO_VECTOR_BEGIN", "AF_NORMAL3F_AUTO_VECTOR_END",
  "AF_UNSIGNED_INT_AUTO_VECTOR_BEGIN", "AF_UNSIGNED_INT_AUTO_VECTOR_END",
  "AF_POINT2RD_VECTOR_BEGIN", "AF_POINT2RD_VECTOR_END",
  "AF_ATTR_MODEL_VIEW", "AF_ATTR_PROJECTION", "AF_ATTR_VIEW_PORT",
  "AF_ATTR_COLOR", "AF_ATTR_DYN_HILITE", "AF_ATTR_HILITE",
  "AF_ATTR_STACK_BREAK", "AF_ATTR_LIST_BEGIN", "AF_ATTR_LIST_END",
  "AF_ATTR_DISPLAY_CONSTRAINTS", "AF_ATTR_ACTIVATE_COMPONENT",
  "AF_ATTR_DRIVING", "AF_ATTR_TOLERANCE_INFO",
  "AF_ATTR_DISPLAY_CONSTRAINTS_V2", "AF_ATTR_TOLERANCE_INFO_V2",
  "AF_ATTR_TOLERANCE_INFO_V3", "AF_ATTR_LINE_WIDTH",
  "AF_ATTR_MATERIAL_MODIFIER", "AF_ATTR_TRANSPARENCY",
  "AF_ATTR_TEXT_SYM_SCALE", "AF_ATTR_LINE_FONT",
  "AF_ATTR_TEXT_SYM_SCALE_V2", "AF_ATTR_DRAWING_REFERENCE",
  "AF_ATTR_COLOR2", "AF_ATTR_TEXTURE_MAPPING", "AF_TESSELLATION_BEGIN",
  "AF_TESSELLATION_END", "AF_TESS_INDEXED_QUAD_ARRAY",
  "AF_TESS_INDEXED_TRIANGLE_ARRAY", "AF_TESS_INDEXED_LINE_ARRAY",
  "AF_TESS_LINE_STRIP_ARRAY", "AF_TESS_POINT_ARRAY", "AF_TESS_TAG_ARRAY",
  "AF_TESS_QUAD_ARRAY", "AF_TESS_TRIANGLE_ARRAY",
  "AF_BASIC_OBJECT_LIST_BEGIN", "AF_BASIC_OBJECT_LIST_END",
  "AF_BASIC_OBJECTS_BEGIN", "AF_BASIC_OBJECTS_END", "AF_OBJECT_NAME",
  "AF_OBJECT_PARENT_FILEID", "AF_COMPONENT_FILE_NAME",
  "AF_COMPONENT_OBJECT_LIST_BEGIN", "AF_COMPONENT_OBJECT_LIST_END",
  "CS_CONS_NEIGHBOR_BEGIN", "CS_CONS_NEIGHBOR_END", "CS_OTR_STATUS",
  "CS_PARAM_NEIGHBOR_BEGIN", "CS_PARAM_NEIGHBOR_END",
  "CS_EQUATION_PARAM_BEGIN", "CS_EQUATION_PARAM_END",
  "AF_POSITION_VECTOR2D", "AF_DYNAMIC_DATA_OBJECT",
  "AF_DYNAMIC_DATA_PARAMETER", "CS_CONS_DYN_NEIGHBOR_BEGIN",
  "CS_CONS_DYN_NEIGHBOR_END", "CS_DYN_OTR_STATUS",
  "CS_PARAM_DYN_NEIGHBOR_BEGIN", "CS_PARAM_DYN_NEIGHBOR_END",
  "AF_LAYER_NUMBER", "AF_LAYER_NAME", "AF_DETAIL_LIST_BEGIN",
  "AF_DETAIL_LIST_END", "AF_CONSTRAINT_DATUM", "AF_LINE_DATUM",
  "AF_OBJECT_DESCRIPTION", "CS_OTR_PRIORITY", "AF_LAST_FILE_ID",
  "AF_POSITION_VECTOR3D", "AF_COMPONENT_BEGIN", "AF_COMPONENT_END",
  "AF_COMPONENT_REF_BEGIN", "AF_COMPONENT_REF_END", "AF_OBJECT_BEGIN",
  "AF_OBJECT_END", "AF_BASIC_OBJECT_BEGIN", "AF_BASIC_OBJECT_END",
  "AF_GROUP_BEGIN", "AF_GROUP_END", "AF_GROUP_REF_BEGIN",
  "AF_GROUP_REF_END", "AF_POINT_BEGIN", "AF_POINT_END",
  "AF_POINT_REF_BEGIN", "AF_POINT_REF_END", "AF_LINE_BEGIN", "AF_LINE_END",
  "AF_LINE_REF_BEGIN", "AF_LINE_REF_END", "CS_POINT2D_BEGIN",
  "CS_POINT2D_END", "CS_POINT2D_REF_BEGIN", "CS_POINT2D_REF_END",
  "CS_LINE2D_BEGIN", "CS_LINE2D_END", "CS_LINE2D_REF_BEGIN",
  "CS_LINE2D_REF_END", "CS_CIRCLE2D_BEGIN", "CS_CIRCLE2D_END",
  "CS_CIRCLE2D_REF_BEGIN", "CS_CIRCLE2D_REF_END",
  "CS_ANGLE_DIMENSION_BEGIN", "CS_ANGLE_DIMENSION_END",
  "CS_ANGLE_DIMENSION_REF_BEGIN", "CS_ANGLE_DIMENSION_REF_END",
  "CS_TRANSFORM_BEGIN", "CS_TRANSFORM_END", "CS_TRANSFORM_REF_BEGIN",
  "CS_TRANSFORM_REF_END", "CS_USER_PARAMETER_BEGIN",
  "CS_USER_PARAMETER_END", "CS_USER_PARAMETER_REF_BEGIN",
  "CS_USER_PARAMETER_REF_END", "CS_POINT_ON_LINE_BEGIN",
  "CS_POINT_ON_LINE_END", "CS_POINT_ON_LINE_REF_BEGIN",
  "CS_POINT_ON_LINE_REF_END", "CS_POINT_TO_POINT_BEGIN",
  "CS_POINT_TO_POINT_END", "CS_POINT_TO_POINT_REF_BEGIN",
  "CS_POINT_TO_POINT_REF_END", "CS_POINT_TO_LINE_BEGIN",
  "CS_POINT_TO_LINE_END", "CS_POINT_TO_LINE_REF_BEGIN",
  "CS_POINT_TO_LINE_REF_END", "CS_COINCIDENT_POINTS_BEGIN",
  "CS_COINCIDENT_POINTS_END", "CS_COINCIDENT_POINTS_REF_BEGIN",
  "CS_COINCIDENT_POINTS_REF_END", "CS_EQUATION_BEGIN", "CS_EQUATION_END",
  "CS_EQUATION_REF_BEGIN", "CS_EQUATION_REF_END",
  "CS_PERPENDICULAR_LINES_BEGIN", "CS_PERPENDICULAR_LINES_END",
  "CS_PERPENDICULAR_LINES_REF_BEGIN", "CS_PERPENDICULAR_LINES_REF_END",
  "CS_COLLINEAR_LINES_BEGIN", "CS_COLLINEAR_LINES_END",
  "CS_COLLINEAR_LINES_REF_BEGIN", "CS_COLLINEAR_LINES_REF_END",
  "CS_PARALLEL_LINES_BEGIN", "CS_PARALLEL_LINES_END",
  "CS_PARALLEL_LINES_REF_BEGIN", "CS_PARALLEL_LINES_REF_END",
  "CS_FIX2D_BEGIN", "CS_FIX2D_END", "CS_FIX2D_REF_BEGIN",
  "CS_FIX2D_REF_END", "CS_MIDPOINT_BEGIN", "CS_MIDPOINT_END",
  "CS_MIDPOINT_REF_BEGIN", "CS_MIDPOINT_REF_END",
  "CS_POINT_ON_CIRCLE_BEGIN", "CS_POINT_ON_CIRCLE_END",
  "CS_POINT_ON_CIRCLE_REF_BEGIN", "CS_POINT_ON_CIRCLE_REF_END",
  "CS_LINE_TANGENT_TO_CIRCLE_BEGIN", "CS_LINE_TANGENT_TO_CIRCLE_END",
  "CS_LINE_TANGENT_TO_CIRCLE_REF_BEGIN",
  "CS_LINE_TANGENT_TO_CIRCLE_REF_END", "CS_CIRCLE_TANGENT_TO_CIRCLE_BEGIN",
  "CS_CIRCLE_TANGENT_TO_CIRCLE_END",
  "CS_CIRCLE_TANGENT_TO_CIRCLE_REF_BEGIN",
  "CS_CIRCLE_TANGENT_TO_CIRCLE_REF_END", "CS_TRANSFORM_POINT_BEGIN",
  "CS_TRANSFORM_POINT_END", "CS_TRANSFORM_POINT_REF_BEGIN",
  "CS_TRANSFORM_POINT_REF_END", "CS_TRANSFORM_CIRCLE_BEGIN",
  "CS_TRANSFORM_CIRCLE_END", "CS_TRANSFORM_CIRCLE_REF_BEGIN",
  "CS_TRANSFORM_CIRCLE_REF_END", "CS_LINE_AT_ANGLE_BEGIN",
  "CS_LINE_AT_ANGLE_END", "CS_LINE_AT_ANGLE_REF_BEGIN",
  "CS_LINE_AT_ANGLE_REF_END", "CS_ANGLE_BETWEEN_LINES_BEGIN",
  "CS_ANGLE_BETWEEN_LINES_END", "CS_ANGLE_BETWEEN_LINES_REF_BEGIN",
  "CS_ANGLE_BETWEEN_LINES_REF_END", "CS_LDIM_EQUAL_LDIM_BEGIN",
  "CS_LDIM_EQUAL_LDIM_END", "CS_LDIM_EQUAL_LDIM_REF_BEGIN",
  "CS_LDIM_EQUAL_LDIM_REF_END", "CS_ADIM_EQUAL_ADIM_BEGIN",
  "CS_ADIM_EQUAL_ADIM_END", "CS_ADIM_EQUAL_ADIM_REF_BEGIN",
  "CS_ADIM_EQUAL_ADIM_REF_END", "CS_LENGTH_DIMENSION_BEGIN",
  "CS_LENGTH_DIMENSION_END", "CS_LENGTH_DIMENSION_REF_BEGIN",
  "CS_LENGTH_DIMENSION_REF_END", "AF_LINE_DATUM_BEGIN",
  "AF_LINE_DATUM_END", "AF_LINE_DATUM_REF_BEGIN", "AF_LINE_DATUM_REF_END",
  "CS_CIRCLE2D_V2_BEGIN", "CS_CIRCLE2D_V2_END", "CS_CIRCLE2D_REF_V2_BEGIN",
  "CS_CIRCLE2D_REF_V2_END", "CS_COINCIDENT_POINTS_V2_BEGIN",
  "CS_COINCIDENT_POINTS_V2_END", "CS_COINCIDENT_POINTS_REF_V2_BEGIN",
  "CS_COINCIDENT_POINTS_REF_V2_END", "CS_POINT_TO_CIRCLE_BEGIN",
  "CS_POINT_TO_CIRCLE_END", "CS_POINT_TO_CIRCLE_REF_BEGIN",
  "CS_POINT_TO_CIRCLE_REF_END", "CS_LINE2D_V2_BEGIN", "CS_LINE2D_V2_END",
  "CS_LINE2D_REF_V2_BEGIN", "CS_LINE2D_REF_V2_END", "CS_ARC_BEGIN",
  "CS_ARC_END", "CS_ARC_REF_BEGIN", "CS_ARC_REF_END", "CS_LINE2D_V3_BEGIN",
  "CS_LINE2D_V3_END", "CS_LINE2D_REF_V3_BEGIN", "CS_LINE2D_REF_V3_END",
  "CS_PERPENDICULAR_LINES_V2_BEGIN", "CS_PERPENDICULAR_LINES_V2_END",
  "CS_PERPENDICULAR_LINES_REF_V2_BEGIN",
  "CS_PERPENDICULAR_LINES_REF_V2_END", "CS_PARALLEL_LINES_V2_BEGIN",
  "CS_PARALLEL_LINES_V2_END", "CS_PARALLEL_LINES_REF_V2_BEGIN",
  "CS_PARALLEL_LINES_REF_V2_END", "CS_ARC_V2_BEGIN", "CS_ARC_V2_END",
  "CS_ARC_REF_V2_BEGIN", "CS_ARC_REF_V2_END", "CS_LINE_TO_LINE_BEGIN",
  "CS_LINE_TO_LINE_END", "CS_LINE_TO_LINE_REF_BEGIN",
  "CS_LINE_TO_LINE_REF_END", "CS_POINT_ARC_POINT_BEGIN",
  "CS_POINT_ARC_POINT_END", "CS_POINT_ARC_POINT_REF_BEGIN",
  "CS_POINT_ARC_POINT_REF_END", "CS_ANGLE_BETWEEN_LINES_V2_BEGIN",
  "CS_ANGLE_BETWEEN_LINES_V2_END", "CS_ANGLE_BETWEEN_LINES_REF_V2_BEGIN",
  "CS_ANGLE_BETWEEN_LINES_REF_V2_END", "AF_SAVEDVIEW_BEGIN",
  "AF_SAVEDVIEW_END", "AF_SAVEDVIEW_PARAM_GROUPS_BEGIN",
  "AF_SAVEDVIEW_PARAM_GROUPS_END", "AF_SAVEDVIEW_EQ_GROUPS_BEGIN",
  "AF_SAVEDVIEW_EQ_GROUPS_END", "AF_SPREADSHEET_BEGIN",
  "AF_SPREADSHEET_END", "AF_SPREADSHEET_EXCEL_DATA_BEGIN",
  "AF_SPREADSHEET_EXCEL_DATA_END", "AF_PARAMETER_GROUP_BEGIN",
  "AF_PARAMETER_GROUP_END", "AF_EQUATION_GROUP_BEGIN",
  "AF_EQUATION_GROUP_END", "CS_EQUATION_V2_BEGIN", "CS_EQUATION_V2_END",
  "CS_USER_PARAMETER_V2_BEGIN", "CS_USER_PARAMETER_V2_END",
  "CS_USER_PARAMETER_REF_V2_BEGIN", "CS_USER_PARAMETER_REF_V2_END",
  "AF_COMPONENT_REF_V2_BEGIN", "AF_COMPONENT_REF_V2_END",
  "CS_ANGLE_BETWEEN_LINES_V3_BEGIN", "CS_ANGLE_BETWEEN_LINES_V3_END",
  "CS_ANGLE_BETWEEN_LINES_REF_V3_BEGIN",
  "CS_ANGLE_BETWEEN_LINES_REF_V3_END", "CS_POINT2D_REF_V2_BEGIN",
  "CS_POINT2D_REF_V2_END", "CS_CIRCLE2D_REF_V3_BEGIN",
  "CS_CIRCLE2D_REF_V3_END", "CS_ARC_REF_V3_BEGIN", "CS_ARC_REF_V3_END",
  "CS_LINE_TO_LINE_REF_V2_BEGIN", "CS_LINE_TO_LINE_REF_V2_END",
  "CS_POINT_ARC_POINT_REF_V2_BEGIN", "CS_POINT_ARC_POINT_REF_V2_END",
  "CS_POINT_TO_LINE_REF_V2_BEGIN", "CS_POINT_TO_LINE_REF_V2_END",
  "CS_LINE_AT_ANGLE_REF_V2_BEGIN", "CS_LINE_AT_ANGLE_REF_V2_END",
  "CS_REGION2D_BEGIN", "CS_REGION2D_END", "CS_REGION2D_REF_BEGIN",
  "CS_REGION2D_REF_END", "CS_REGION_LIST_BEGIN", "CS_REGION_LIST_END",
  "CS_HOLE_LIST_BEGIN", "CS_HOLE_LIST_END", "CS_AREA_DIMENSION_BEGIN",
  "CS_AREA_DIMENSION_END", "CS_AREA_DIMENSION_REF_BEGIN",
  "CS_AREA_DIMENSION_REF_END", "CS_AREA_BEGIN", "CS_AREA_END",
  "CS_AREA_REF_BEGIN", "CS_AREA_REF_END", "AF_LAYER_BEGIN", "AF_LAYER_END",
  "AF_VIEW_BEGIN", "AF_VIEW_END", "CS_POINT3D_BEGIN", "CS_POINT3D_END",
  "CS_POINT3D_REF_BEGIN", "CS_POINT3D_REF_END", "CS_LINE3D_BEGIN",
  "CS_LINE3D_END", "CS_LINE3D_REF_BEGIN", "CS_LINE3D_REF_END",
  "CS_POINT_TO_POINT3D_BEGIN", "CS_POINT_TO_POINT3D_END",
  "CS_POINT_TO_POINT3D_REF_BEGIN", "CS_POINT_TO_POINT3D_REF_END",
  "AF_POSITION_CONSTRAINT_BEGIN", "AF_POSITION_CONSTRAINT_END",
  "AF_POSITION_CONSTRAINT_REF_BEGIN", "AF_POSITION_CONSTRAINT_REF_END",
  "CS_ANGLE_BETWEEN_LINES_V4_BEGIN", "CS_ANGLE_BETWEEN_LINES_V4_END",
  "CS_ANGLE_BETWEEN_LINES_REF_V4_BEGIN",
  "CS_ANGLE_BETWEEN_LINES_REF_V4_END", "CS_COINCIDENT_POINTS3D_BEGIN",
  "CS_COINCIDENT_POINTS3D_END", "CS_COINCIDENT_POINTS3D_REF_BEGIN",
  "CS_COINCIDENT_POINTS3D_REF_END", "CS_CENTROID_BEGIN", "CS_CENTROID_END",
  "CS_CENTROID_REF_BEGIN", "CS_CENTROID_REF_END", "AF_DEFAULT_BEGIN",
  "AF_DEFAULT_END", "CS_CENTROID_V2_BEGIN", "CS_CENTROID_V2_END",
  "CS_CENTROID_REF_V2_BEGIN", "CS_CENTROID_REF_V2_END",
  "CS_LINE_TO_LINE_V3_BEGIN", "CS_LINE_TO_LINE_V3_END",
  "CS_LINE_TO_LINE_REF_V3_BEGIN", "CS_LINE_TO_LINE_REF_V3_END",
  "CS_AREA_DIMENSION_V2_BEGIN", "CS_AREA_DIMENSION_V2_END",
  "CS_AREA_DIMENSION_REF_V2_BEGIN", "CS_AREA_DIMENSION_REF_V2_END",
  "CS_SECOND_MOMENT_BEGIN", "CS_SECOND_MOMENT_END",
  "CS_SECOND_MOMENT_REF_BEGIN", "CS_SECOND_MOMENT_REF_END",
  "CS_POINT_MOMENT_BEGIN", "CS_POINT_MOMENT_END",
  "CS_POINT_MOMENT_REF_BEGIN", "CS_POINT_MOMENT_REF_END",
  "CS_LINE_MOMENT_BEGIN", "CS_LINE_MOMENT_END", "CS_LINE_MOMENT_REF_BEGIN",
  "CS_LINE_MOMENT_REF_END", "CS_ANGLE_BETWEEN_LINES_V5_BEGIN",
  "CS_ANGLE_BETWEEN_LINES_V5_END", "CS_ANGLE_BETWEEN_LINES_REF_V5_BEGIN",
  "CS_ANGLE_BETWEEN_LINES_REF_V5_END",
  "AF_REPETITIVE_SIZE_DIMENSION_BEGIN", "AF_REPETITIVE_SIZE_DIMENSION_END",
  "AF_REPETITIVE_SIZE_DIMENSION_REF_BEGIN",
  "AF_REPETITIVE_SIZE_DIMENSION_REF_END",
  "AF_REPETITIVE_SPACE_DIMENSION_BEGIN",
  "AF_REPETITIVE_SPACE_DIMENSION_END",
  "AF_REPETITIVE_SPACE_DIMENSION_REF_BEGIN",
  "AF_REPETITIVE_SPACE_DIMENSION_REF_END", "AF_DUPLICATE_BEGIN",
  "AF_DUPLICATE_END", "AF_COMPONENT_REF_V3_BEGIN",
  "AF_COMPONENT_REF_V3_END", "AF_CIRCLE_DATUM_BEGIN",
  "AF_CIRCLE_DATUM_END", "AF_CIRCLE_DATUM_REF_BEGIN",
  "AF_CIRCLE_DATUM_REF_END", "AF_CIRCLE_DATUM_V2_BEGIN",
  "AF_CIRCLE_DATUM_V2_END", "AF_CIRCLE_DATUM_REF_V2_BEGIN",
  "AF_CIRCLE_DATUM_REF_V2_END", "AF_CENTER_LINE_BEGIN",
  "AF_CENTER_LINE_END", "AF_CENTER_LINE_REF_BEGIN",
  "AF_CENTER_LINE_REF_END", "AF_CIRCLE_DATUM_V3_BEGIN",
  "AF_CIRCLE_DATUM_V3_END", "AF_CIRCLE_DATUM_REF_V3_BEGIN",
  "AF_CIRCLE_DATUM_REF_V3_END", "CS_LINEAR_INTERPOLATION_BEGIN",
  "CS_LINEAR_INTERPOLATION_END", "CS_LINEAR_INTERPOLATION_REF_BEGIN",
  "CS_LINEAR_INTERPOLATION_REF_END", "CS_ANGLE_DIMENSION_V2_BEGIN",
  "CS_ANGLE_DIMENSION_V2_END", "CS_ANGLE_DIMENSION_REF_V2_BEGIN",
  "CS_ANGLE_DIMENSION_REF_V2_END", "CS_LENGTH_DIMENSION_V2_BEGIN",
  "CS_LENGTH_DIMENSION_V2_END", "CS_LENGTH_DIMENSION_REF_V2_BEGIN",
  "CS_LENGTH_DIMENSION_REF_V2_END", "AF_TEXT_BEGIN", "AF_TEXT_END",
  "AF_TEXT_REF_BEGIN", "AF_TEXT_REF_END", "AF_CENTER_LINE_V2_BEGIN",
  "AF_CENTER_LINE_V2_END", "AF_CENTER_LINE_REF_V2_BEGIN",
  "AF_CENTER_LINE_REF_V2_END", "CS_TRANSFORM2D_V2_BEGIN",
  "CS_TRANSFORM2D_V2_END", "CS_TRANSFORM_REF_V2_BEGIN",
  "CS_TRANSFORM_REF_V2_END", "CS_POINT2D_REF_V3_BEGIN",
  "CS_POINT2D_REF_V3_END", "CS_CIRCLE2D_REF_V4_BEGIN",
  "CS_CIRCLE2D_REF_V4_END", "CS_ARC_REF_V4_BEGIN", "CS_ARC_REF_V4_END",
  "CS_VECTOR2D_BEGIN", "CS_VECTOR2D_END", "CS_VECTOR2D_REF_BEGIN",
  "CS_VECTOR2D_REF_END", "CS_VECTOR_END_POINTS_BEGIN",
  "CS_VECTOR_END_POINTS_END", "CS_VECTOR_END_POINTS_REF_BEGIN",
  "CS_VECTOR_END_POINTS_REF_END", "CS_VECTOR_LENGTH_BEGIN",
  "CS_VECTOR_LENGTH_END", "CS_VECTOR_LENGTH_REF_BEGIN",
  "CS_VECTOR_LENGTH_REF_END", "CS_VECTOR_X_BEGIN", "CS_VECTOR_X_END",
  "CS_VECTOR_X_REF_BEGIN", "CS_VECTOR_X_REF_END", "CS_VECTOR_Y_BEGIN",
  "CS_VECTOR_Y_END", "CS_VECTOR_Y_REF_BEGIN", "CS_VECTOR_Y_REF_END",
  "CS_VECTORS_EQUAL_BEGIN", "CS_VECTORS_EQUAL_END",
  "CS_VECTORS_EQUAL_REF_BEGIN", "CS_VECTORS_EQUAL_REF_END",
  "CS_VECTORS_OPPOSITE_BEGIN", "CS_VECTORS_OPPOSITE_END",
  "CS_VECTORS_OPPOSITE_REF_BEGIN", "CS_VECTORS_OPPOSITE_REF_END",
  "CS_VECTOR_PARALLEL_LINE_BEGIN", "CS_VECTOR_PARALLEL_LINE_END",
  "CS_VECTOR_PARALLEL_LINE_REF_BEGIN", "CS_VECTOR_PARALLEL_LINE_REF_END",
  "CS_VECTOR_PARALLEL_VECTOR_BEGIN", "CS_VECTOR_PARALLEL_VECTOR_END",
  "CS_VECTOR_PARALLEL_VECTOR_REF_BEGIN",
  "CS_VECTOR_PARALLEL_VECTOR_REF_END", "CS_VECTOR_PERP_LINE_BEGIN",
  "CS_VECTOR_PERP_LINE_END", "CS_VECTOR_PERP_LINE_REF_BEGIN",
  "CS_VECTOR_PERP_LINE_REF_END", "CS_VECTOR_PERP_VECTOR_BEGIN",
  "CS_VECTOR_PERP_VECTOR_END", "CS_VECTOR_PERP_VECTOR_REF_BEGIN",
  "CS_VECTOR_PERP_VECTOR_REF_END", "CS_VECTOR_AT_ANGLE_BEGIN",
  "CS_VECTOR_AT_ANGLE_END", "CS_VECTOR_AT_ANGLE_REF_BEGIN",
  "CS_VECTOR_AT_ANGLE_REF_END", "CS_VECTOR_ANGLE_LINE_BEGIN",
  "CS_VECTOR_ANGLE_LINE_END", "CS_VECTOR_ANGLE_LINE_REF_BEGIN",
  "CS_VECTOR_ANGLE_LINE_REF_END", "CS_VECTOR_ANGLE_VECTOR_BEGIN",
  "CS_VECTOR_ANGLE_VECTOR_END", "CS_VECTOR_ANGLE_VECTOR_REF_BEGIN",
  "CS_VECTOR_ANGLE_VECTOR_REF_END", "CS_VECTOR_SUM_BEGIN",
  "CS_VECTOR_SUM_END", "CS_VECTOR_SUM_REF_BEGIN", "CS_VECTOR_SUM_REF_END",
  "CS_VECTOR_MOMENT_SUM_BEGIN", "CS_VECTOR_MOMENT_SUM_END",
  "CS_VECTOR_MOMENT_SUM_REF_BEGIN", "CS_VECTOR_MOMENT_SUM_REF_END",
  "CS_VECTOR_TANGENT_CIRCLE_BEGIN", "CS_VECTOR_TANGENT_CIRCLE_END",
  "CS_VECTOR_TANGENT_CIRCLE_REF_BEGIN", "CS_VECTOR_TANGENT_CIRCLE_REF_END",
  "CS_VECTOR_NORMAL_CIRCLE_BEGIN", "CS_VECTOR_NORMAL_CIRCLE_END",
  "CS_VECTOR_NORMAL_CIRCLE_REF_BEGIN", "CS_VECTOR_NORMAL_CIRCLE_REF_END",
  "CS_PROFILE_BEGIN", "CS_PROFILE_END", "CS_PROFILE_REF_BEGIN",
  "CS_PROFILE_REF_END", "CS_CIRCLE_NORMAL_PROFILE_BEGIN",
  "CS_CIRCLE_NORMAL_PROFILE_END", "CS_CIRCLE_NORMAL_PROFILE_REF_BEGIN",
  "CS_CIRCLE_NORMAL_PROFILE_REF_END", "CS_CIRCLE_TANGENT_PROFILE_BEGIN",
  "CS_CIRCLE_TANGENT_PROFILE_END", "CS_CIRCLE_TANGENT_PROFILE_REF_BEGIN",
  "CS_CIRCLE_TANGENT_PROFILE_REF_END", "CS_LINE_NORMAL_PROFILE_BEGIN",
  "CS_LINE_NORMAL_PROFILE_END", "CS_LINE_NORMAL_PROFILE_REF_BEGIN",
  "CS_LINE_NORMAL_PROFILE_REF_END", "CS_LINE_TANGENT_PROFILE_BEGIN",
  "CS_LINE_TANGENT_PROFILE_END", "CS_LINE_TANGENT_PROFILE_REF_BEGIN",
  "CS_LINE_TANGENT_PROFILE_REF_END", "CS_POINT_ON_PROFILE_BEGIN",
  "CS_POINT_ON_PROFILE_END", "CS_POINT_ON_PROFILE_REF_BEGIN",
  "CS_POINT_ON_PROFILE_REF_END", "CS_PROFILE_LENGTH_BEGIN",
  "CS_PROFILE_LENGTH_END", "CS_PROFILE_LENGTH_REF_BEGIN",
  "CS_PROFILE_LENGTH_REF_END", "CS_PROFILE_NORMAL_PROFILE_BEGIN",
  "CS_PROFILE_NORMAL_PROFILE_END", "CS_PROFILE_NORMAL_PROFILE_REF_BEGIN",
  "CS_PROFILE_NORMAL_PROFILE_REF_END", "CS_PROFILE_TANGENT_PROFILE_BEGIN",
  "CS_PROFILE_TANGENT_PROFILE_END", "CS_PROFILE_TANGENT_PROFILE_REF_BEGIN",
  "CS_PROFILE_TANGENT_PROFILE_REF_END", "CS_VECTOR_NORMAL_PROFILE_BEGIN",
  "CS_VECTOR_NORMAL_PROFILE_END", "CS_VECTOR_NORMAL_PROFILE_REF_BEGIN",
  "CS_VECTOR_NORMAL_PROFILE_REF_END", "CS_VECTOR_TANGENT_PROFILE_BEGIN",
  "CS_VECTOR_TANGENT_PROFILE_END", "CS_VECTOR_TANGENT_PROFILE_REF_BEGIN",
  "CS_VECTOR_TANGENT_PROFILE_REF_END", "CS_VECTOR_SCALE_BEGIN",
  "CS_VECTOR_SCALE_END", "CS_VECTOR_SCALE_REF_BEGIN",
  "CS_VECTOR_SCALE_REF_END", "CS_PROFILE_T_BEGIN", "CS_PROFILE_T_END",
  "CS_PROFILE_T_REF_BEGIN", "CS_PROFILE_T_REF_END", "CS_FRICTION_BEGIN",
  "CS_FRICTION_END", "CS_FRICTION_REF_BEGIN", "CS_FRICTION_REF_END",
  "CS_FRICTION_COEF_BEGIN", "CS_FRICTION_COEF_END",
  "CS_FRICTION_COEF_REF_BEGIN", "CS_FRICTION_COEF_REF_END",
  "CS_HOLE_PATTERN_BEGIN", "CS_HOLE_PATTERN_END",
  "CS_HOLE_PATTERN_REF_BEGIN", "CS_HOLE_PATTERN_REF_END",
  "CS_SLOT_LENGTH_BEGIN", "CS_SLOT_LENGTH_END", "CS_SLOT_LENGTH_REF_BEGIN",
  "CS_SLOT_LENGTH_REF_END", "CS_VECTOR_MOMENT_BEGIN",
  "CS_VECTOR_MOMENT_END", "CS_VECTOR_MOMENT_REF_BEGIN",
  "CS_VECTOR_MOMENT_REF_END", "CS_HOLE_PATTERN_V2_BEGIN",
  "CS_HOLE_PATTERN_V2_END", "CS_HOLE_PATTERN_REF_V2_BEGIN",
  "CS_HOLE_PATTERN_REF_V2_END", "CS_FORCE_BEGIN", "CS_FORCE_END",
  "CS_FORCE_REF_BEGIN", "CS_FORCE_REF_END", "CS_VECTOR_LENGTH_V2_BEGIN",
  "CS_VECTOR_LENGTH_V2_END", "CS_VECTOR_LENGTH_REF_V2_BEGIN",
  "CS_VECTOR_LENGTH_REF_V2_END", "CS_VELOCITY_BEGIN", "CS_VELOCITY_END",
  "CS_VELOCITY_REF_BEGIN", "CS_VELOCITY_REF_END", "CS_ACCELERATION_BEGIN",
  "CS_ACCELERATION_END", "CS_ACCELERATION_REF_BEGIN",
  "CS_ACCELERATION_REF_END", "CS_MOMENT_SUM_BEGIN", "CS_MOMENT_SUM_END",
  "CS_MOMENT_SUM_REF_BEGIN", "CS_MOMENT_SUM_REF_END",
  "CS_DIRECTION_VECTOR3D_BEGIN", "CS_DIRECTION_VECTOR3D_END",
  "CS_DIRECTION_VECTOR3D_REF_BEGIN", "CS_DIRECTION_VECTOR3D_REF_END",
  "CS_PLANE3D_BEGIN", "CS_PLANE3D_END", "CS_PLANE3D_REF_BEGIN",
  "CS_PLANE3D_REF_END", "CS_UNIT_VECTOR3D_BEGIN", "CS_UNIT_VECTOR3D_END",
  "CS_UNIT_VECTOR3D_REF_BEGIN", "CS_UNIT_VECTOR3D_REF_END",
  "CS_POINT_ON_PLANE3D_BEGIN", "CS_POINT_ON_PLANE3D_END",
  "CS_POINT_ON_PLANE3D_REF_BEGIN", "CS_POINT_ON_PLANE3D_REF_END",
  "CS_POINT_TO_PLANE3D_BEGIN", "CS_POINT_TO_PLANE3D_END",
  "CS_POINT_TO_PLANE3D_REF_BEGIN", "CS_POINT_TO_PLANE3D_REF_END",
  "AF_VIEW_V2_BEGIN", "AF_VIEW_V2_END", "CS_POINT_TO_PLANE3D_V2_BEGIN",
  "CS_POINT_TO_PLANE3D_V2_END", "CS_POINT_TO_PLANE3D_REF_V2_BEGIN",
  "CS_POINT_TO_PLANE3D_REF_V2_END", "CS_GRIDDED_PARALLEL_BEGIN",
  "CS_GRIDDED_PARALLEL_END", "CS_GRIDDED_PARALLEL_REF_BEGIN",
  "CS_GRIDDED_PARALLEL_REF_END", "CS_GRIDDED_PERP_BEGIN",
  "CS_GRIDDED_PERP_END", "CS_GRIDDED_PERP_REF_BEGIN",
  "CS_GRIDDED_PERP_REF_END", "CS_LINE_CIRCLE_LENGTH_BEGIN",
  "CS_LINE_CIRCLE_LENGTH_END", "CS_LINE_CIRCLE_LENGTH_REF_BEGIN",
  "CS_LINE_CIRCLE_LENGTH_REF_END", "CS_POINT_CIRCLE_LENGTH_BEGIN",
  "CS_POINT_CIRCLE_LENGTH_END", "CS_POINT_CIRCLE_LENGTH_REF_BEGIN",
  "CS_POINT_CIRCLE_LENGTH_REF_END", "CS_LINE_NORMAL_CIRCLE_BEGIN",
  "CS_LINE_NORMAL_CIRCLE_END", "CS_LINE_NORMAL_CIRCLE_REF_BEGIN",
  "CS_LINE_NORMAL_CIRCLE_REF_END", "CS_POINT_ON_VECTOR_BEGIN",
  "CS_POINT_ON_VECTOR_END", "CS_POINT_ON_VECTOR_REF_BEGIN",
  "CS_POINT_ON_VECTOR_REF_END", "CS_MOMENTS_EQUAL_BEGIN",
  "CS_MOMENTS_EQUAL_END", "CS_MOMENTS_EQUAL_REF_BEGIN",
  "CS_MOMENTS_EQUAL_REF_END", "CS_MOMENTS_OPPOSITE_BEGIN",
  "CS_MOMENTS_OPPOSITE_END", "CS_MOMENTS_OPPOSITE_REF_BEGIN",
  "CS_MOMENTS_OPPOSITE_REF_END", "CS_EQUATION_V3_BEGIN",
  "CS_EQUATION_V3_END", "CS_VECTOR_TANGENT_CIRCLE_V2_BEGIN",
  "CS_VECTOR_TANGENT_CIRCLE_V2_END",
  "CS_VECTOR_TANGENT_CIRCLE_REF_V2_BEGIN",
  "CS_VECTOR_TANGENT_CIRCLE_REF_V2_END",
  "CS_VECTOR_NORMAL_CIRCLE_V2_BEGIN", "CS_VECTOR_NORMAL_CIRCLE_V2_END",
  "CS_VECTOR_NORMAL_CIRCLE_REF_V2_BEGIN",
  "CS_VECTOR_NORMAL_CIRCLE_REF_V2_END", "AF_POSITION_CONSTRAINT_V2_BEGIN",
  "AF_POSITION_CONSTRAINT_V2_END", "AF_POSITION_CONSTRAINT_REF_V2_BEGIN",
  "AF_POSITION_CONSTRAINT_REF_V2_END", "CS_REGION3D_BEGIN",
  "CS_REGION3D_END", "CS_REGION3D_REF_BEGIN", "CS_REGION3D_REF_END",
  "CS_PARALLEL_DIRECTIONS3D_BEGIN", "CS_PARALLEL_DIRECTIONS3D_END",
  "CS_PARALLEL_DIRECTIONS3D_REF_BEGIN", "CS_PARALLEL_DIRECTIONS3D_REF_END",
  "CS_PERPENDICULAR_PLANES3D_BEGIN", "CS_PERPENDICULAR_PLANES3D_END",
  "CS_PERPENDICULAR_PLANES3D_REF_BEGIN",
  "CS_PERPENDICULAR_PLANES3D_REF_END", "CS_ANGLE_BETWEEN_PLANES3D_BEGIN",
  "CS_ANGLE_BETWEEN_PLANES3D_END", "CS_ANGLE_BETWEEN_PLANES3D_REF_BEGIN",
  "CS_ANGLE_BETWEEN_PLANES3D_REF_END", "CS_PLANE_TO_PLANE3D_BEGIN",
  "CS_PLANE_TO_PLANE3D_END", "CS_PLANE_TO_PLANE3D_REF_BEGIN",
  "CS_PLANE_TO_PLANE3D_REF_END", "AF_VIEW_V3_BEGIN", "AF_VIEW_V3_END",
  "AF_PLANE_DATUM3D_BEGIN", "AF_PLANE_DATUM3D_END",
  "AF_PLANE_DATUM3D_REF_BEGIN", "AF_PLANE_DATUM3D_REF_END",
  "CS_FACET_LIST_BEGIN", "CS_FACET_LIST_END", "CS_SOLID_PRIMITIVE3D_BEGIN",
  "CS_SOLID_PRIMITIVE3D_END", "CS_SOLID_PRIMITIVE3D_REF_BEGIN",
  "CS_SOLID_PRIMITIVE3D_REF_END", "CS_CONST_SOLID_GEOM_NODE3D_BEGIN",
  "CS_CONST_SOLID_GEOM_NODE3D_END", "CS_CONST_SOLID_GEOM3D_BEGIN",
  "CS_CONST_SOLID_GEOM3D_END", "CS_CONST_SOLID_GEOM3D_REF_BEGIN",
  "CS_CONST_SOLID_GEOM3D_REF_END", "CS_QUATERNION_BEGIN",
  "CS_QUATERNION_END", "AF_SKETCH_PLANE_GROUP_BEGIN",
  "AF_SKETCH_PLANE_GROUP_END", "AF_SKETCH_PLANE_GROUP_REF_BEGIN",
  "AF_SKETCH_PLANE_GROUP_REF_END", "CS_SKETCH_PLANE3D_BEGIN",
  "CS_SKETCH_PLANE3D_END", "CS_SKETCH_PLANE3D_REF_BEGIN",
  "CS_SKETCH_PLANE3D_REF_END", "CS_LINE_END_POINTS3D_BEGIN",
  "CS_LINE_END_POINTS3D_END", "CS_LINE_END_POINTS3D_REF_BEGIN",
  "CS_LINE_END_POINTS3D_REF_END", "CS_PRIMARY_GROUND3D_BEGIN",
  "CS_PRIMARY_GROUND3D_END", "CS_PRIMARY_GROUND3D_REF_BEGIN",
  "CS_PRIMARY_GROUND3D_REF_END", "CS_SECONDARY_GROUND3D_BEGIN",
  "CS_SECONDARY_GROUND3D_END", "CS_SECONDARY_GROUND3D_REF_BEGIN",
  "CS_SECONDARY_GROUND3D_REF_END", "CS_UNIT_QUATERNION_BEGIN",
  "CS_UNIT_QUATERNION_END", "CS_UNIT_QUATERNION_REF_BEGIN",
  "CS_UNIT_QUATERNION_REF_END", "CS_Z_AXIS_NORMAL_TO_PLANE3D_BEGIN",
  "CS_Z_AXIS_NORMAL_TO_PLANE3D_END",
  "CS_Z_AXIS_NORMAL_TO_PLANE3D_REF_BEGIN",
  "CS_Z_AXIS_NORMAL_TO_PLANE3D_REF_END",
  "CS_X_AXIS_PARALLEL_TO_PLANE3D_BEGIN",
  "CS_X_AXIS_PARALLEL_TO_PLANE3D_END",
  "CS_X_AXIS_PARALLEL_TO_PLANE3D_REF_BEGIN",
  "CS_X_AXIS_PARALLEL_TO_PLANE3D_REF_END", "CS_2D3D_BEGIN", "CS_2D3D_END",
  "CS_2D3D_REF_BEGIN", "CS_2D3D_REF_END", "CS_Z_DISPLACEMENT_BEGIN",
  "CS_Z_DISPLACEMENT_END", "CS_Z_DISPLACEMENT_REF_BEGIN",
  "CS_Z_DISPLACEMENT_REF_END", "CS_PROJECT_BETWEEN_SKETCH_PLANES3D_BEGIN",
  "CS_PROJECT_BETWEEN_SKETCH_PLANES3D_END",
  "CS_PROJECT_BETWEEN_SKETCH_PLANES3D_REF_BEGIN",
  "CS_PROJECT_BETWEEN_SKETCH_PLANES3D_REF_END",
  "CS_Z1_PARALLEL_Y23D_BEGIN", "CS_Z1_PARALLEL_Y23D_END",
  "CS_Z1_PARALLEL_Y23D_REF_BEGIN", "CS_Z1_PARALLEL_Y23D_REF_END",
  "CS_3D_LINE_NORMAL_Z3D_BEGIN", "CS_3D_LINE_NORMAL_Z3D_END",
  "CS_3D_LINE_NORMAL_Z3D_REF_BEGIN", "CS_3D_LINE_NORMAL_Z3D_REF_END",
  "CS_GROUND_QUATERNION3D_BEGIN", "CS_GROUND_QUATERNION3D_END",
  "CS_GROUND_QUATERNION3D_REF_BEGIN", "CS_GROUND_QUATERNION3D_REF_END",
  "CS_TRANSFORM3D_BEGIN", "CS_TRANSFORM3D_END", "CS_FIX3D_BEGIN",
  "CS_FIX3D_END", "CS_FIX3D_REF_BEGIN", "CS_FIX3D_REF_END",
  "CS_FIX2D_V2_BEGIN", "CS_FIX2D_V2_END", "CS_FIX2D_REF_V2_BEGIN",
  "CS_FIX2D_REF_V2_END", "CS_LINE_LENGTH_BEGIN", "CS_LINE_LENGTH_END",
  "CS_LINE_LENGTH_REF_BEGIN", "CS_LINE_LENGTH_REF_END",
  "CS_ARC_ANGLE_BEGIN", "CS_ARC_ANGLE_END", "CS_ARC_ANGLE_REF_BEGIN",
  "CS_ARC_ANGLE_REF_END", "CS_ARC_OFFSET_BEGIN", "CS_ARC_OFFSET_END",
  "CS_ARC_OFFSET_REF_BEGIN", "CS_ARC_OFFSET_REF_END", "CS_NEWARC2D_BEGIN",
  "CS_NEWARC2D_END", "CS_NEWARC2D_REF_BEGIN", "CS_NEWARC2D_REF_END",
  "CS_LINE_END_POINTS_2D_BEGIN", "CS_LINE_END_POINTS_2D_END",
  "CS_LINE_END_POINTS_2D_REF_BEGIN", "CS_LINE_END_POINTS_2D_REF_END",
  "CS_POINT_ON_NEWARC_BEGIN", "CS_POINT_ON_NEWARC_END",
  "CS_POINT_ON_NEWARC_REF_BEGIN", "CS_POINT_ON_NEWARC_REF_END",
  "CS_LINE_TANGENT_NEWARC_BEGIN", "CS_LINE_TANGENT_NEWARC_END",
  "CS_LINE_TANGENT_NEWARC_REF_BEGIN", "CS_LINE_TANGENT_NEWARC_REF_END",
  "CS_NEWARC_TANGENT_NEWARC_BEGIN", "CS_NEWARC_TANGENT_NEWARC_END",
  "CS_NEWARC_TANGENT_NEWARC_REF_BEGIN", "CS_NEWARC_TANGENT_NEWARC_REF_END",
  "CS_CIRCLE_TANGENT_NEWARC_BEGIN", "CS_CIRCLE_TANGENT_NEWARC_END",
  "CS_CIRCLE_TANGENT_NEWARC_REF_BEGIN", "CS_CIRCLE_TANGENT_NEWARC_REF_END",
  "CS_NEWARC_RADIUS_DIM_BEGIN", "CS_NEWARC_RADIUS_DIM_END",
  "CS_NEWARC_RADIUS_DIM_REF_BEGIN", "CS_NEWARC_RADIUS_DIM_REF_END",
  "CS_NEWARC_CENTER_BEGIN", "CS_NEWARC_CENTER_END",
  "CS_NEWARC_CENTER_REF_BEGIN", "CS_NEWARC_CENTER_REF_END",
  "CS_CIRCLE_CONCENTRIC_NEWARC_BEGIN", "CS_CIRCLE_CONCENTRIC_NEWARC_END",
  "CS_CIRCLE_CONCENTRIC_NEWARC_REF_BEGIN",
  "CS_CIRCLE_CONCENTRIC_NEWARC_REF_END",
  "CS_NEWARC_CONCENTRIC_NEWARC_BEGIN", "CS_NEWARC_CONCENTRIC_NEWARC_END",
  "CS_NEWARC_CONCENTRIC_NEWARC_REF_BEGIN",
  "CS_NEWARC_CONCENTRIC_NEWARC_REF_END", "CS_VECTOR_TANGENT_NEWARC_BEGIN",
  "CS_VECTOR_TANGENT_NEWARC_END", "CS_VECTOR_TANGENT_NEWARC_REF_BEGIN",
  "CS_VECTOR_TANGENT_NEWARC_REF_END", "CS_VECTOR_NORMAL_NEWARC_BEGIN",
  "CS_VECTOR_NORMAL_NEWARC_END", "CS_VECTOR_NORMAL_NEWARC_REF_BEGIN",
  "CS_VECTOR_NORMAL_NEWARC_REF_END", "CS_NEWARC_LENGTH_DIM_BEGIN",
  "CS_NEWARC_LENGTH_DIM_END", "CS_NEWARC_LENGTH_DIM_REF_BEGIN",
  "CS_NEWARC_LENGTH_DIM_REF_END", "CS_LINE_NORMAL_NEWARC_BEGIN",
  "CS_LINE_NORMAL_NEWARC_END", "CS_LINE_NORMAL_NEWARC_REF_BEGIN",
  "CS_LINE_NORMAL_NEWARC_REF_END", "CS_CIRCLE_NORMAL_NEWARC_BEGIN",
  "CS_CIRCLE_NORMAL_NEWARC_END", "CS_CIRCLE_NORMAL_NEWARC_REF_BEGIN",
  "CS_CIRCLE_NORMAL_NEWARC_REF_END", "AF_COMPONENT_V4_BEGIN",
  "AF_COMPONENT_V4_END", "AF_COMPONENT_REF_V4_BEGIN",
  "AF_COMPONENT_REF_V4_END", "CS_POINT_NEWARC_LENGTH_BEGIN",
  "CS_POINT_NEWARC_LENGTH_END", "CS_POINT_NEWARC_LENGTH_REF_BEGIN",
  "CS_POINT_NEWARC_LENGTH_REF_END", "CS_LINE_NEWARC_LENGTH_BEGIN",
  "CS_LINE_NEWARC_LENGTH_END", "CS_LINE_NEWARC_LENGTH_REF_BEGIN",
  "CS_LINE_NEWARC_LENGTH_REF_END", "CS_CIRCLE_NEWARC_LENGTH_BEGIN",
  "CS_CIRCLE_NEWARC_LENGTH_END", "CS_CIRCLE_NEWARC_LENGTH_REF_BEGIN",
  "CS_CIRCLE_NEWARC_LENGTH_REF_END", "CS_NEWARC_NEWARC_LENGTH_BEGIN",
  "CS_NEWARC_NEWARC_LENGTH_END", "CS_NEWARC_NEWARC_LENGTH_REF_BEGIN",
  "CS_NEWARC_NEWARC_LENGTH_REF_END", "CS_NEWARC_NORMAL_POLYCURVE_BEGIN",
  "CS_NEWARC_NORMAL_POLYCURVE_END", "CS_NEWARC_NORMAL_POLYCURVE_REF_BEGIN",
  "CS_NEWARC_NORMAL_POLYCURVE_REF_END",
  "CS_NEWARC_TANGENT_POLYCURVE_BEGIN", "CS_NEWARC_TANGENT_POLYCURVE_END",
  "CS_NEWARC_TANGENT_POLYCURVE_REF_BEGIN",
  "CS_NEWARC_TANGENT_POLYCURVE_REF_END", "CS_CIRCLE3D_BEGIN",
  "CS_CIRCLE3D_END", "CS_CIRCLE3D_REF_BEGIN", "CS_CIRCLE3D_REF_END",
  "CS_SMART_PTR_LIST_BEGIN", "CS_SMART_PTR_LIST_END",
  "CS_POINT3D_REF_V2_BEGIN", "CS_POINT3D_REF_V2_END",
  "CS_LINE3D_REF_V2_BEGIN", "CS_LINE3D_REF_V2_END", "CS_LINE3D_V3_BEGIN",
  "CS_LINE3D_V3_END", "CS_LINE3D_REF_V3_BEGIN", "CS_LINE3D_REF_V3_END",
  "CS_POINT_ON_LINE3D_BEGIN", "CS_POINT_ON_LINE3D_END",
  "CS_POINT_ON_LINE3D_REF_BEGIN", "CS_POINT_ON_LINE3D_REF_END",
  "CS_LINE_LENGTH3D_BEGIN", "CS_LINE_LENGTH3D_END",
  "CS_LINE_LENGTH3D_REF_BEGIN", "CS_LINE_LENGTH3D_REF_END",
  "AF_SAVEDVIEW_V2_BEGIN", "AF_SAVEDVIEW_V2_END",
  "CS_TRANSFORM2D_V3_BEGIN", "CS_TRANSFORM2D_V3_END",
  "CS_LINE_CIRCLE_LENGTH_V2_BEGIN", "CS_LINE_CIRCLE_LENGTH_V2_END",
  "CS_LINE_CIRCLE_LENGTH_REF_V2_BEGIN", "CS_LINE_CIRCLE_LENGTH_REF_V2_END",
  "CS_GRIDDED_PARALLEL_V2_BEGIN", "CS_GRIDDED_PARALLEL_V2_END",
  "CS_GRIDDED_PARALLEL_REF_V2_BEGIN", "CS_GRIDDED_PARALLEL_REF_V2_END",
  "CS_GRIDDED_PERP_V2_BEGIN", "CS_GRIDDED_PERP_V2_END",
  "CS_GRIDDED_PERP_REF_V2_BEGIN", "CS_GRIDDED_PERP_REF_V2_END",
  "CS_POINT_CIRCLE_LENGTH_V2_BEGIN", "CS_POINT_CIRCLE_LENGTH_V2_END",
  "CS_POINT_CIRCLE_LENGTH_REF_V2_BEGIN",
  "CS_POINT_CIRCLE_LENGTH_REF_V2_END", "CS_NEWARC_NORMAL_NEWARC_BEGIN",
  "CS_NEWARC_NORMAL_NEWARC_END", "CS_NEWARC_NORMAL_NEWARC_REF_BEGIN",
  "CS_NEWARC_NORMAL_NEWARC_REF_END", "AF_MATH_GROUP_BEGIN",
  "AF_MATH_GROUP_END", "AF_MATH_GROUP_PARAM_BEGIN",
  "AF_MATH_GROUP_PARAM_END", "AF_MATH_GROUP_EQN_BEGIN",
  "AF_MATH_GROUP_EQN_END", "CS_NEWARC_POINT_AT_MIDPOINT_BEGIN",
  "CS_NEWARC_POINT_AT_MIDPOINT_END",
  "CS_NEWARC_POINT_AT_MIDPOINT_REF_BEGIN",
  "CS_NEWARC_POINT_AT_MIDPOINT_REF_END", "CS_LINE_SYMMETRY_POINTS2D_BEGIN",
  "CS_LINE_SYMMETRY_POINTS2D_END", "CS_LINE_SYMMETRY_POINTS2D_REF_BEGIN",
  "CS_LINE_SYMMETRY_POINTS2D_REF_END", "CS_LINE_SYMMETRY_CIRCLES2D_BEGIN",
  "CS_LINE_SYMMETRY_CIRCLES2D_END", "CS_LINE_SYMMETRY_CIRCLES2D_REF_BEGIN",
  "CS_LINE_SYMMETRY_CIRCLES2D_REF_END", "CS_LINE_SYMMETRY_NEWARCS2D_BEGIN",
  "CS_LINE_SYMMETRY_NEWARCS2D_END", "CS_LINE_SYMMETRY_NEWARCS2D_REF_BEGIN",
  "CS_LINE_SYMMETRY_NEWARCS2D_REF_END", "CS_CONSTANT_THICKNESS2D_BEGIN",
  "CS_CONSTANT_THICKNESS2D_END", "CS_CONSTANT_THICKNESS2D_REF_BEGIN",
  "CS_CONSTANT_THICKNESS2D_REF_END", "CS_LINE_SYMMETRY_LINES2D_BEGIN",
  "CS_LINE_SYMMETRY_LINES2D_END", "CS_LINE_SYMMETRY_LINES2D_REF_BEGIN",
  "CS_LINE_SYMMETRY_LINES2D_REF_END", "CS_CYLINDER3D_BEGIN",
  "CS_CYLINDER3D_END", "CS_CYLINDER3D_REF_BEGIN", "CS_CYLINDER3D_REF_END",
  "CS_CIRCLE3D_V2_BEGIN", "CS_CIRCLE3D_V2_END", "CS_CIRCLE3D_REF_V2_BEGIN",
  "CS_CIRCLE3D_REF_V2_END", "CS_NEWARC3D_BEGIN", "CS_NEWARC3D_END",
  "CS_NEWARC3D_REF_BEGIN", "CS_NEWARC3D_REF_END",
  "CS_ARC_END_POINTS_3D_BEGIN", "CS_ARC_END_POINTS_3D_END",
  "CS_ARC_END_POINTS_3D_REF_BEGIN", "CS_ARC_END_POINTS_3D_REF_END",
  "CS_POINT_ON_CYLINDER3D_BEGIN", "CS_POINT_ON_CYLINDER3D_END",
  "CS_POINT_ON_CYLINDER3D_REF_BEGIN", "CS_POINT_ON_CYLINDER3D_REF_END",
  "CS_CYLINDER3D_V2_BEGIN", "CS_CYLINDER3D_V2_END",
  "CS_CYLINDER3D_REF_V2_BEGIN", "CS_CYLINDER3D_REF_V2_END",
  "CS_LINE_TO_LINE_V4_BEGIN", "CS_LINE_TO_LINE_V4_END",
  "CS_LINE_TO_LINE_REF_V4_BEGIN", "CS_LINE_TO_LINE_REF_V4_END",
  "AF_DIM_DATUM_BEGIN", "AF_DIM_DATUM_END", "AF_DIM_DATUM_REF_BEGIN",
  "AF_DIM_DATUM_REF_END", "CS_Y_AXIS_PARALLEL_TO_PLANE3D_BEGIN",
  "CS_Y_AXIS_PARALLEL_TO_PLANE3D_END",
  "CS_Y_AXIS_PARALLEL_TO_PLANE3D_REF_BEGIN",
  "CS_Y_AXIS_PARALLEL_TO_PLANE3D_REF_END",
  "CS_Z_AXIS_PARALLEL_TO_PLANE3D_BEGIN",
  "CS_Z_AXIS_PARALLEL_TO_PLANE3D_END",
  "CS_Z_AXIS_PARALLEL_TO_PLANE3D_REF_BEGIN",
  "CS_Z_AXIS_PARALLEL_TO_PLANE3D_REF_END", "AF_DIM_DATUM",
  "CS_ARC_QUATERNION_BEGIN", "CS_ARC_QUATERNION_END",
  "CS_ARC_QUATERNION_REF_BEGIN", "CS_ARC_QUATERNION_REF_END",
  "CS_CYLINDERS_POINT_CONTACT3D_BEGIN", "CS_CYLINDERS_POINT_CONTACT3D_END",
  "CS_CYLINDERS_POINT_CONTACT3D_REF_BEGIN",
  "CS_CYLINDERS_POINT_CONTACT3D_REF_END", "CS_POINT_ON_LINE_V2_BEGIN",
  "CS_POINT_ON_LINE_V2_END", "CS_POINT_ON_LINE_REF_V2_BEGIN",
  "CS_POINT_ON_LINE_REF_V2_END", "CS_LINE_TO_LINE_V5_BEGIN",
  "CS_LINE_TO_LINE_V5_END", "CS_LINE_TO_LINE_REF_V5_BEGIN",
  "CS_LINE_TO_LINE_REF_V5_END", "CS_NEWARC_CENTER3D_BEGIN",
  "CS_NEWARC_CENTER3D_END", "CS_NEWARC_CENTER3D_REF_BEGIN",
  "CS_NEWARC_CENTER3D_REF_END", "AF_ATTR_TOLERANCE_INFO_V4",
  "AF_NURBS_CURVE3D_BEGIN", "AF_NURBS_CURVE3D_END",
  "AF_NURBS_SURFACE3D_BEGIN", "AF_NURBS_SURFACE3D_END",
  "AF_NURBS_CONTROL_POLYGON3D_BEGIN", "AF_NURBS_CONTROL_POLYGON3D_END",
  "AF_NURBS_KNOTS_BEGIN", "AF_NURBS_KNOTS_END",
  "AF_NURBS_CONTROL_NET_BEGIN", "AF_NURBS_CONTROL_NET_END",
  "AF_NURBS_TRIM_INSTANCE_BEGIN", "AF_NURBS_TRIM_INSTANCE_END",
  "CS_MATING_PLANES3D_BEGIN", "CS_MATING_PLANES3D_END",
  "CS_MATING_PLANES3D_REF_BEGIN", "CS_MATING_PLANES3D_REF_END",
  "CS_MATING_PLANES3D_V2_BEGIN", "CS_MATING_PLANES3D_V2_END",
  "CS_MATING_PLANES3D_REF_V2_BEGIN", "CS_MATING_PLANES3D_REF_V2_END",
  "CS_MATING_CYLINDERS_PRIMARY3D_BEGIN",
  "CS_MATING_CYLINDERS_PRIMARY3D_END",
  "CS_MATING_CYLINDERS_PRIMARY3D_REF_BEGIN",
  "CS_MATING_CYLINDERS_PRIMARY3D_REF_END",
  "CS_MATING_CYLINDERS_SECONDARY3D_BEGIN",
  "CS_MATING_CYLINDERS_SECONDARY3D_END",
  "CS_MATING_CYLINDERS_SECONDARY3D_REF_BEGIN",
  "CS_MATING_CYLINDERS_SECONDARY3D_REF_END",
  "CS_MATING_CYLINDERS_TERTIARY3D_BEGIN",
  "CS_MATING_CYLINDERS_TERTIARY3D_END",
  "CS_MATING_CYLINDERS_TERTIARY3D_REF_BEGIN",
  "CS_MATING_CYLINDERS_TERTIARY3D_REF_END", "CS_CYLINDER3D_V3_BEGIN",
  "CS_CYLINDER3D_V3_END", "CS_CYLINDER3D_REF_V3_BEGIN",
  "CS_CYLINDER3D_REF_V3_END", "CS_TABLE_BEGIN", "CS_TABLE_END",
  "CS_TABLE_REF_BEGIN", "CS_TABLE_REF_END", "CS_LINE_SEGMENT2D_BEGIN",
  "CS_LINE_SEGMENT2D_END", "CS_LINE_SEGMENT2D_REF_BEGIN",
  "CS_LINE_SEGMENT2D_REF_END", "CS_LINE_SEGMENT3D_BEGIN",
  "CS_LINE_SEGMENT3D_END", "CS_LINE_SEGMENT3D_REF_BEGIN",
  "CS_LINE_SEGMENT3D_REF_END", "AF_ATTR_TOLERANCE_INFO_V5",
  "CS_SIDE_VIEW_FPIH_BEGIN", "CS_SIDE_VIEW_FPIH_END",
  "CS_SIDE_VIEW_FPIH_REF_BEGIN", "CS_SIDE_VIEW_FPIH_REF_END",
  "CS_BIAS_PIN_IN_HOLE_BEGIN", "CS_BIAS_PIN_IN_HOLE_END",
  "CS_BIAS_PIN_IN_HOLE_REF_BEGIN", "CS_BIAS_PIN_IN_HOLE_REF_END",
  "CS_USER_TABLE_BEGIN", "CS_USER_TABLE_END", "CS_USER_TABLE_REF_BEGIN",
  "CS_USER_TABLE_REF_END", "AF_CIRCLE_DATUM_V4_BEGIN",
  "AF_CIRCLE_DATUM_V4_END", "AF_CIRCLE_DATUM_REF_V4_BEGIN",
  "AF_CIRCLE_DATUM_REF_V4_END", "CS_CONSTANT_THICKNESS2D_V2_BEGIN",
  "CS_CONSTANT_THICKNESS2D_V2_END", "CS_CONSTANT_THICKNESS2D_REF_V2_BEGIN",
  "CS_CONSTANT_THICKNESS2D_REF_V2_END",
  "CS_UNIV_PARAM_EQUAL_UNIV_PARAM_BEGIN",
  "CS_UNIV_PARAM_EQUAL_UNIV_PARAM_END",
  "CS_UNIV_PARAM_EQUAL_UNIV_PARAM_REF_BEGIN",
  "CS_UNIV_PARAM_EQUAL_UNIV_PARAM_REF_END", "CS_NEWARC_CYLINDER3D_BEGIN",
  "CS_NEWARC_CYLINDER3D_END", "CS_NEWARC_CYLINDER3D_REF_BEGIN",
  "CS_NEWARC_CYLINDER3D_REF_END", "AF_CONTINUOUS_FEATURE2D_BEGIN",
  "AF_CONTINUOUS_FEATURE2D_END", "AF_CONTINUOUS_FEATURE2D_REF_BEGIN",
  "AF_CONTINUOUS_FEATURE2D_REF_END", "AF_CONTINUOUS_FEATURE3D_BEGIN",
  "AF_CONTINUOUS_FEATURE3D_END", "AF_CONTINUOUS_FEATURE3D_REF_BEGIN",
  "AF_CONTINUOUS_FEATURE3D_REF_END", "CS_PROJECT_POINTS3D_BEGIN",
  "CS_PROJECT_POINTS3D_END", "CS_PROJECT_POINTS3D_REF_BEGIN",
  "CS_PROJECT_POINTS3D_REF_END", "CS_TRANSFORM2D_SCALED_V3_BEGIN",
  "CS_TRANSFORM2D_SCALED_V3_END", "AF_CSSCENARIO_BEGIN",
  "AF_CSSCENARIO_END", "AF_CSSCENARIO_LIST_BEGIN",
  "AF_CSSCENARIO_LIST_END", "AF_STRAIGHT_CURVE3D_BEGIN",
  "AF_STRAIGHT_CURVE3D_END", "AF_ORDERED_GROUP_BEGIN",
  "AF_ORDERED_GROUP_END", "AF_ORDERED_GROUP_OBJS_BEGIN",
  "AF_ORDERED_GROUP_OBJS_END", "CS_POINT_TO_POINT3D_V2_BEGIN",
  "CS_POINT_TO_POINT3D_V2_END", "CS_POINT_TO_POINT3D_REF_V2_BEGIN",
  "CS_POINT_TO_POINT3D_REF_V2_END", "CS_PLANE_TO_PLANE3D_V2_BEGIN",
  "CS_PLANE_TO_PLANE3D_V2_END", "CS_PLANE_TO_PLANE3D_REF_V2_BEGIN",
  "CS_PLANE_TO_PLANE3D_REF_V2_END", "CS_LINE_LENGTH3D_V2_BEGIN",
  "CS_LINE_LENGTH3D_V2_END", "CS_LINE_LENGTH3D_REF_V2_BEGIN",
  "CS_LINE_LENGTH3D_REF_V2_END", "CS_POINT_ON_PLANE3D_V2_BEGIN",
  "CS_POINT_ON_PLANE3D_V2_END", "CS_POINT_ON_PLANE3D_REF_V2_BEGIN",
  "CS_POINT_ON_PLANE3D_REF_V2_END", "CS_COINCIDENT_POINTS3D_V2_BEGIN",
  "CS_COINCIDENT_POINTS3D_V2_END", "CS_COINCIDENT_POINTS3D_REF_V2_BEGIN",
  "CS_COINCIDENT_POINTS3D_REF_V2_END", "CS_GROUND_QUATERNION3D_V2_BEGIN",
  "CS_GROUND_QUATERNION3D_V2_END", "CS_PRIMARY_GROUND3D_V2_BEGIN",
  "CS_PRIMARY_GROUND3D_V2_END", "CS_PRIMARY_GROUND3D_REF_V2_BEGIN",
  "CS_PRIMARY_GROUND3D_REF_V2_END", "CS_SECONDARY_GROUND3D_V2_BEGIN",
  "CS_SECONDARY_GROUND3D_V2_END", "CS_SECONDARY_GROUND3D_REF_V2_BEGIN",
  "CS_SECONDARY_GROUND3D_REF_V2_END", "CS_FIX3D_V2_BEGIN",
  "CS_FIX3D_V2_END", "CS_FIX3D_REF_V2_BEGIN", "CS_FIX3D_REF_V2_END",
  "CS_POINT_ON_LINE3D_V2_BEGIN", "CS_POINT_ON_LINE3D_V2_END",
  "CS_POINT_ON_LINE3D_REF_V2_BEGIN", "CS_POINT_ON_LINE3D_REF_V2_END",
  "CS_MATING_PLANES3D_V3_BEGIN", "CS_MATING_PLANES3D_V3_END",
  "CS_MATING_PLANES3D_REF_V3_BEGIN", "CS_MATING_PLANES3D_REF_V3_END",
  "CS_NEWARC_CENTER3D_V2_BEGIN", "CS_NEWARC_CENTER3D_V2_END",
  "CS_NEWARC_CENTER3D_REF_V2_BEGIN", "CS_NEWARC_CENTER3D_REF_V2_END",
  "CS_POINT_ON_CYLINDER3D_V2_BEGIN", "CS_POINT_ON_CYLINDER3D_V2_END",
  "CS_POINT_ON_CYLINDER3D_REF_V2_BEGIN",
  "CS_POINT_ON_CYLINDER3D_REF_V2_END",
  "CS_CYLINDERS_POINT_CONTACT3D_V2_BEGIN",
  "CS_CYLINDERS_POINT_CONTACT3D_V2_END",
  "CS_CYLINDERS_POINT_CONTACT3D_REF_V2_BEGIN",
  "CS_CYLINDERS_POINT_CONTACT3D_REF_V2_END",
  "CS_MATING_CYLINDERS_PRIMARY3D_V2_BEGIN",
  "CS_MATING_CYLINDERS_PRIMARY3D_V2_END",
  "CS_MATING_CYLINDERS_PRIMARY3D_REF_V2_BEGIN",
  "CS_MATING_CYLINDERS_PRIMARY3D_REF_V2_END", "CS_PLANE3D_V2_BEGIN",
  "CS_PLANE3D_V2_END", "CS_PLANE3D_REF_V2_BEGIN", "CS_PLANE3D_REF_V2_END",
  "CS_LOCK_SPIN2D_BEGIN", "CS_LOCK_SPIN2D_END", "CS_LOCK_SPIN2D_REF_BEGIN",
  "CS_LOCK_SPIN2D_REF_END", "CS_ANGLE_BETWEEN_CYLINDERS3D_BEGIN",
  "CS_ANGLE_BETWEEN_CYLINDERS3D_END",
  "CS_ANGLE_BETWEEN_CYLINDERS3D_REF_BEGIN",
  "CS_ANGLE_BETWEEN_CYLINDERS3D_REF_END",
  "CS_ANGLE_BETWEEN_CYLINDER_AND_PLANE3D_BEGIN",
  "CS_ANGLE_BETWEEN_CYLINDER_AND_PLANE3D_END",
  "CS_ANGLE_BETWEEN_CYLINDER_AND_PLANE3D_REF_BEGIN",
  "CS_ANGLE_BETWEEN_CYLINDER_AND_PLANE3D_REF_END", "CS_LOCK_SPIN3D_BEGIN",
  "CS_LOCK_SPIN3D_END", "CS_LOCK_SPIN3D_REF_BEGIN",
  "CS_LOCK_SPIN3D_REF_END", "CS_MATING_PLANES3D_V4_BEGIN",
  "CS_MATING_PLANES3D_V4_END", "CS_MATING_PLANES3D_REF_V4_BEGIN",
  "CS_MATING_PLANES3D_REF_V4_END", "CS_MATING_CYLINDERS3D_V3_BEGIN",
  "CS_MATING_CYLINDERS3D_V3_END", "CS_MATING_CYLINDERS3D_REF_V3_BEGIN",
  "CS_MATING_CYLINDERS3D_REF_V3_END", "CS_EQ_MATING_CYLINDERS3D_V3_BEGIN",
  "CS_EQ_MATING_CYLINDERS3D_V3_END",
  "CS_EQ_MATING_CYLINDERS3D_REF_V3_BEGIN",
  "CS_EQ_MATING_CYLINDERS3D_REF_V3_END", "AF_ATTR_TOLERANCE_INFO_V6",
  "CS_MATING_CYLINDERS3D_V4_BEGIN", "CS_MATING_CYLINDERS3D_V4_END",
  "CS_MATING_CYLINDERS3D_REF_V4_BEGIN", "CS_MATING_CYLINDERS3D_REF_V4_END",
  "CS_CYLINDER3D_V4_BEGIN", "CS_CYLINDER3D_V4_END",
  "CS_CYLINDER3D_REF_V4_BEGIN", "CS_CYLINDER3D_REF_V4_END",
  "CS_SPHERE3D_BEGIN", "CS_SPHERE3D_END", "CS_SPHERE3D_REF_BEGIN",
  "CS_SPHERE3D_REF_END", "CS_POINT_ON_CIRCLE3D_BEGIN",
  "CS_POINT_ON_CIRCLE3D_END", "CS_POINT_ON_CIRCLE3D_REF_BEGIN",
  "CS_POINT_ON_CIRCLE3D_REF_END", "CS_POINT_TO_AXIS3D_BEGIN",
  "CS_POINT_TO_AXIS3D_END", "CS_POINT_TO_AXIS3D_REF_BEGIN",
  "CS_POINT_TO_AXIS3D_REF_END", "CS_ANGLE_AXIS_PLANE3D_BEGIN",
  "CS_ANGLE_AXIS_PLANE3D_END", "CS_ANGLE_AXIS_PLANE3D_REF_BEGIN",
  "CS_ANGLE_AXIS_PLANE3D_REF_END", "CS_CIRCLE_CONTACTS_PLANE3D_BEGIN",
  "CS_CIRCLE_CONTACTS_PLANE3D_END", "CS_CIRCLE_CONTACTS_PLANE3D_REF_BEGIN",
  "CS_CIRCLE_CONTACTS_PLANE3D_REF_END", "AF_ATTR_TOLERANCE_INFO_V7",
  "AF_ATTR_TOLERANCE_INFO_V8", "CS_ANGLE_BETWEEN_PLANES3D_V2_BEGIN",
  "CS_ANGLE_BETWEEN_PLANES3D_V2_END",
  "CS_ANGLE_BETWEEN_PLANES3D_REF_V2_BEGIN",
  "CS_ANGLE_BETWEEN_PLANES3D_REF_V2_END",
  "CS_ANGLE_BETWEEN_CYLINDERS3D_V2_BEGIN",
  "CS_ANGLE_BETWEEN_CYLINDERS3D_V2_END",
  "CS_ANGLE_BETWEEN_CYLINDERS3D_REF_V2_BEGIN",
  "CS_ANGLE_BETWEEN_CYLINDERS3D_REF_V2_END",
  "CS_ANGLE_BETWEEN_CYLINDER_AND_PLANE3D_V2_BEGIN",
  "CS_ANGLE_BETWEEN_CYLINDER_AND_PLANE3D_V2_END",
  "CS_ANGLE_BETWEEN_CYLINDER_AND_PLANE3D_REF_V2_BEGIN",
  "CS_ANGLE_BETWEEN_CYLINDER_AND_PLANE3D_REF_V2_END",
  "CS_ANGLE_AXIS_PLANE3D_V2_BEGIN", "CS_ANGLE_AXIS_PLANE3D_V2_END",
  "CS_ANGLE_AXIS_PLANE3D_REF_V2_BEGIN", "CS_ANGLE_AXIS_PLANE3D_REF_V2_END",
  "AF_CYLINDER_DATUM3D_BEGIN", "AF_CYLINDER_DATUM3D_END",
  "AF_CYLINDER_DATUM3D_REF_BEGIN", "AF_CYLINDER_DATUM3D_REF_END",
  "CS_CYLINDER3D_V5_BEGIN", "CS_CYLINDER3D_V5_END",
  "CS_CYLINDER3D_REF_V5_BEGIN", "CS_CYLINDER3D_REF_V5_END",
  "CS_PLANE3D_V3_BEGIN", "CS_PLANE3D_V3_END", "CS_PLANE3D_REF_V3_BEGIN",
  "CS_PLANE3D_REF_V3_END", "AF_ATTR_TOLERANCE_INFO_V9",
  "AF_COMPONENT_REF_V5_BEGIN", "AF_COMPONENT_REF_V5_END",
  "AF_SPREADSHEET_V2_BEGIN", "AF_SPREADSHEET_V2_END",
  "AF_SPREADSHEET_BINARY_DATA_BEGIN", "AF_SPREADSHEET_BINARY_DATA_END",
  "AF_NURBS_CURVE2D_BEGIN", "AF_NURBS_CURVE2D_END",
  "AF_STRAIGHT_CURVE2D_BEGIN", "AF_STRAIGHT_CURVE2D_END",
  "AF_NURBS_CONTROL_POLYGON2D_BEGIN", "AF_NURBS_CONTROL_POLYGON2D_END",
  "AF_ATTR_TOLERANCE_INFO_V10", "CS_COINCIDENT_POINTS_V3_BEGIN",
  "CS_COINCIDENT_POINTS_V3_END", "CS_COINCIDENT_POINTS_REF_V3_BEGIN",
  "CS_COINCIDENT_POINTS_REF_V3_END",
  "CS_CIRCLE_CONCENTRIC_NEWARC_V2_BEGIN",
  "CS_CIRCLE_CONCENTRIC_NEWARC_V2_END",
  "CS_CIRCLE_CONCENTRIC_NEWARC_REF_V2_BEGIN",
  "CS_CIRCLE_CONCENTRIC_NEWARC_REF_V2_END",
  "CS_NEWARC_CONCENTRIC_NEWARC_V2_BEGIN",
  "CS_NEWARC_CONCENTRIC_NEWARC_V2_END",
  "CS_NEWARC_CONCENTRIC_NEWARC_REF_V2_BEGIN",
  "CS_NEWARC_CONCENTRIC_NEWARC_REF_V2_END", "AF_CIRCLE_DATUM_V5_BEGIN",
  "AF_CIRCLE_DATUM_V5_END", "AF_CIRCLE_DATUM_REF_V5_BEGIN",
  "AF_CIRCLE_DATUM_REF_V5_END", "AF_TOL_PROP_VALUE_BEGIN",
  "AF_TOL_PROP_VALUE_END", "AF_ATTR_TOLERANCE_INFO_V11",
  "AF_TOL_PROP_VALUE_LIST_BEGIN", "AF_TOL_PROP_VALUE_LIST_END",
  "AF_ANNOTATION_PLANE3D_BEGIN", "AF_ANNOTATION_PLANE3D_END",
  "AF_ANNOTATION_PLANE3D_V2_BEGIN", "AF_ANNOTATION_PLANE3D_V2_END",
  "CS_PLANE_CONSTRAINT3D_BEGIN", "CS_PLANE_CONSTRAINT3D_END",
  "CS_PLANE_CONSTRAINT3D_REF_BEGIN", "CS_PLANE_CONSTRAINT3D_REF_END",
  "AF_ATTR_TOLERANCE_INFO_V12", "AF_COMPONENT_V5_BEGIN",
  "AF_COMPONENT_V5_END", "AF_POSITION_CONSTRAINT_V3_BEGIN",
  "AF_POSITION_CONSTRAINT_V3_END", "AF_POSITION_CONSTRAINT_REF_V3_BEGIN",
  "AF_POSITION_CONSTRAINT_REF_V3_END", "AF_ANNOTATION_PLANE3D_V4_BEGIN",
  "AF_ANNOTATION_PLANE3D_V4_END", "CS_LINE_TO_PLANE3D_V1_BEGIN",
  "CS_LINE_TO_PLANE3D_V1_END", "CS_LINE_TO_PLANE3D_REF_V1_BEGIN",
  "CS_LINE_TO_PLANE3D_REF_V1_END", "CS_COAXIAL3D_BEGIN",
  "CS_COAXIAL3D_END", "CS_COAXIAL3D_REF_BEGIN", "CS_COAXIAL3D_REF_END",
  "CS_CYLINDER_SIZE3D_V1_BEGIN", "CS_CYLINDER_SIZE3D_V1_END",
  "CS_CYLINDER_SIZE3D_REF_V1_BEGIN", "CS_CYLINDER_SIZE3D_REF_V1_END",
  "CS_CYLINDER_TANGENT_PLANE3D_BEGIN", "CS_CYLINDER_TANGENT_PLANE3D_END",
  "CS_CYLINDER_TANGENT_PLANE3D_REF_BEGIN",
  "CS_CYLINDER_TANGENT_PLANE3D_REF_END", "AF_POSITION_CONSTRAINT_3D_BEGIN",
  "AF_POSITION_CONSTRAINT_3D_END", "AF_POSITION_CONSTRAINT_3D_REF_BEGIN",
  "AF_POSITION_CONSTRAINT_3D_REF_END", "CS_CYLINDER3D_V6_BEGIN",
  "CS_CYLINDER3D_V6_END", "CS_CYLINDER3D_REF_V6_BEGIN",
  "CS_CYLINDER3D_REF_V6_END", "CS_CYLINDER_TAPER3D_BEGIN",
  "CS_CYLINDER_TAPER3D_END", "CS_CYLINDER_TAPER3D_REF_BEGIN",
  "CS_CYLINDER_TAPER3D_REF_END", "AF_POSITION_CONSTRAINT_3D_V2_BEGIN",
  "AF_POSITION_CONSTRAINT_3D_V2_END",
  "AF_POSITION_CONSTRAINT_3D_REF_V2_BEGIN",
  "AF_POSITION_CONSTRAINT_3D_REF_V2_END", "AF_PLANE_DATUM3D_V2_BEGIN",
  "AF_PLANE_DATUM3D_V2_END", "AF_PLANE_DATUM3D_REF_V2_BEGIN",
  "AF_PLANE_DATUM3D_REF_V2_END", "AF_ANNOTATION_PLANE3D_V3_BEGIN",
  "AF_ANNOTATION_PLANE3D_V3_END", "CS_OTR_DATUM_CASE",
  "CS_RECTANGULAR_SIZE_BEGIN", "CS_RECTANGULAR_SIZE_END",
  "CS_RECTANGULAR_SIZE_REF_BEGIN", "CS_RECTANGULAR_SIZE_REF_END",
  "CS_RECTANGULAR_POSITION_BEGIN", "CS_RECTANGULAR_POSITION_END",
  "CS_RECTANGULAR_POSITION_REF_BEGIN", "CS_RECTANGULAR_POSITION_REF_END",
  "AF_NURBS_CURVE2D_REF_BEGIN", "AF_NURBS_CURVE2D_REF_END",
  "AF_STRAIGHT_CURVE2D_REF_BEGIN", "AF_STRAIGHT_CURVE2D_REF_END",
  "AF_NURBS_CURVE3D_REF_BEGIN", "AF_NURBS_CURVE3D_REF_END",
  "AF_STRAIGHT_CURVE3D_REF_BEGIN", "AF_STRAIGHT_CURVE3D_REF_END",
  "AF_NURBS_SURFACE3D_REF_BEGIN", "AF_NURBS_SURFACE3D_REF_END",
  "AF_NURBS_SURFACE3D_V1_BEGIN", "AF_NURBS_SURFACE3D_V1_END",
  "AF_NURBS_CURVE3D_V1_BEGIN", "AF_NURBS_CURVE3D_V1_END",
  "CS_LINE3D_V4_BEGIN", "CS_LINE3D_V4_END", "CS_LINE3D_REF_V4_BEGIN",
  "CS_LINE3D_REF_V4_END", "AF_FCF3D_BEGIN", "AF_FCF3D_END",
  "AF_FCF3D_REF_BEGIN", "AF_FCF3D_REF_END",
  "CS_PARALLEL_DIRECTIONS3D_V2_BEGIN", "CS_PARALLEL_DIRECTIONS3D_V2_END",
  "CS_PARALLEL_DIRECTIONS3D_REF_V2_BEGIN",
  "CS_PARALLEL_DIRECTIONS3D_REF_V2_END", "CS_NEWARC3D_V2_BEGIN",
  "CS_NEWARC3D_V2_END", "CS_NEWARC3D_REF_V2_BEGIN",
  "CS_NEWARC3D_REF_V2_END", "CS_CIRCLE3D_V3_BEGIN", "CS_CIRCLE3D_V3_END",
  "CS_CIRCLE3D_REF_V3_BEGIN", "CS_CIRCLE3D_REF_V3_END",
  "CS_PERPENDICULAR_PLANES3D_V2_BEGIN", "CS_PERPENDICULAR_PLANES3D_V2_END",
  "CS_PERPENDICULAR_PLANES3D_REF_V2_BEGIN",
  "CS_PERPENDICULAR_PLANES3D_REF_V2_END",
  "CS_COINCIDENT_POINTS_REF_V4_BEGIN", "CS_COINCIDENT_POINTS_V4_BEGIN",
  "CS_COINCIDENT_POINTS_V4_END", "CS_COINCIDENT_POINTS_REF_V4_END",
  "CS_MIDPOINT3D_BEGIN", "CS_MIDPOINT3D_END", "CS_MIDPOINT3D_REF_BEGIN",
  "CS_MIDPOINT3D_REF_END", "CS_LINE_TO_LINE3D_V1_BEGIN",
  "CS_LINE_TO_LINE3D_V1_END", "CS_LINE_TO_LINE3D_REF_V1_BEGIN",
  "CS_LINE_TO_LINE3D_REF_V1_END", "CS_MIDPOINT3D_V2_BEGIN",
  "CS_MIDPOINT3D_V2_END", "CS_MIDPOINT3D_REF_V2_BEGIN",
  "CS_MIDPOINT3D_REF_V2_END", "CS_LINE_ON_CYLINDER_3D_BEGIN",
  "CS_LINE_ON_CYLINDER_3D_END", "CS_LINE_ON_CYLINDER_3D_REF_BEGIN",
  "CS_LINE_ON_CYLINDER_3D_REF_END",
  "CS_CYLINDER_TANGENT_CYLINDER_3D_BEGIN",
  "CS_CYLINDER_TANGENT_CYLINDER_3D_END",
  "CS_CYLINDER_TANGENT_CYLINDER_3D_REF_BEGIN",
  "CS_CYLINDER_TANGENT_CYLINDER_3D_REF_END",
  "CS_CIRCLE_CONCENTRIC_NEWARC_V3_BEGIN",
  "CS_CIRCLE_CONCENTRIC_NEWARC_V3_END",
  "CS_CIRCLE_CONCENTRIC_NEWARC_REF_V3_BEGIN",
  "CS_CIRCLE_CONCENTRIC_NEWARC_REF_V3_END",
  "CS_NEWARC_CONCENTRIC_NEWARC_V3_BEGIN",
  "CS_NEWARC_CONCENTRIC_NEWARC_V3_END",
  "CS_NEWARC_CONCENTRIC_NEWARC_REF_V3_BEGIN",
  "CS_NEWARC_CONCENTRIC_NEWARC_REF_V3_END", "CS_CYLINDER3D_V7_BEGIN",
  "CS_CYLINDER3D_V7_END", "$accept", "input", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  parser::yyrline_[] =
  {
       0,  1873,  1873
  };

  void
  parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


} // yy
#line 1827 "C:\\Users\\Vince\\Projects\\Enventive\\ensrc\\EnAp\\ApReadBinary.tab.cpp"

#line 1880 "C:\\Users\\Vince\\Projects\\Enventive\\ensrc\\EnAp\\ApReadBinary.ypp"

